xref: /linux/scripts/link-vmlinux.sh (revision 9d106c6dd81bb26ad7fc3ee89cb1d62557c8e2c9)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37	if [ "${quiet}" != "silent_" ]; then
38		printf "  %-7s %s\n" "${1}" "${2}"
39	fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
46	local objects
47
48	objects="--whole-archive				\
49		${KBUILD_VMLINUX_OBJS}				\
50		--no-whole-archive				\
51		--start-group					\
52		${KBUILD_VMLINUX_LIBS}				\
53		--end-group"
54
55	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56}
57
58# Link of vmlinux
59# ${1} - output file
60# ${2}, ${3}, ... - optional extra .o files
61vmlinux_link()
62{
63	local lds="${objtree}/${KBUILD_LDS}"
64	local output=${1}
65	local objects
66	local strip_debug
67
68	info LD ${output}
69
70	# skip output file argument
71	shift
72
73	# The kallsyms linking does not need debug symbols included.
74	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
75		strip_debug=-Wl,--strip-debug
76	fi
77
78	if [ "${SRCARCH}" != "um" ]; then
79		objects="--whole-archive			\
80			${KBUILD_VMLINUX_OBJS}			\
81			--no-whole-archive			\
82			--start-group				\
83			${KBUILD_VMLINUX_LIBS}			\
84			--end-group				\
85			${@}"
86
87		${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}	\
88			${strip_debug#-Wl,}			\
89			-o ${output}				\
90			-T ${lds} ${objects}
91	else
92		objects="-Wl,--whole-archive			\
93			${KBUILD_VMLINUX_OBJS}			\
94			-Wl,--no-whole-archive			\
95			-Wl,--start-group			\
96			${KBUILD_VMLINUX_LIBS}			\
97			-Wl,--end-group				\
98			${@}"
99
100		${CC} ${CFLAGS_vmlinux}				\
101			${strip_debug}				\
102			-o ${output}				\
103			-Wl,-T,${lds}				\
104			${objects}				\
105			-lutil -lrt -lpthread
106		rm -f linux
107	fi
108}
109
110# generate .BTF typeinfo from DWARF debuginfo
111# ${1} - vmlinux image
112# ${2} - file to dump raw BTF data into
113gen_btf()
114{
115	local pahole_ver
116	local bin_arch
117	local bin_format
118	local bin_file
119
120	if ! [ -x "$(command -v ${PAHOLE})" ]; then
121		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
122		return 1
123	fi
124
125	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
126	if [ "${pahole_ver}" -lt "113" ]; then
127		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
128		return 1
129	fi
130
131	vmlinux_link ${1}
132
133	info "BTF" ${2}
134	LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
135
136	# dump .BTF section into raw binary file to link with final vmlinux
137	bin_arch=$(LANG=C ${OBJDUMP} -f ${1} | grep architecture | \
138		cut -d, -f1 | cut -d' ' -f2)
139	bin_format=$(LANG=C ${OBJDUMP} -f ${1} | grep 'file format' | \
140		awk '{print $4}')
141	bin_file=.btf.vmlinux.bin
142	${OBJCOPY} --change-section-address .BTF=0 \
143		--set-section-flags .BTF=alloc -O binary \
144		--only-section=.BTF ${1} $bin_file
145	${OBJCOPY} -I binary -O ${bin_format} -B ${bin_arch} \
146		--rename-section .data=.BTF $bin_file ${2}
147}
148
149# Create ${2} .o file with all symbols from the ${1} object file
150kallsyms()
151{
152	info KSYM ${2}
153	local kallsymopt;
154
155	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
156		kallsymopt="${kallsymopt} --all-symbols"
157	fi
158
159	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
160		kallsymopt="${kallsymopt} --absolute-percpu"
161	fi
162
163	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
164		kallsymopt="${kallsymopt} --base-relative"
165	fi
166
167	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
168		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
169
170	local afile="`basename ${2} .o`.S"
171
172	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
173	${CC} ${aflags} -c -o ${2} ${afile}
174}
175
176# Perform one step in kallsyms generation, including temporary linking of
177# vmlinux.
178kallsyms_step()
179{
180	kallsymso_prev=${kallsymso}
181	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
182	kallsymso=${kallsyms_vmlinux}.o
183
184	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
185	kallsyms ${kallsyms_vmlinux} ${kallsymso}
186}
187
188# Create map file with all symbols from ${1}
189# See mksymap for additional details
190mksysmap()
191{
192	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
193}
194
195sorttable()
196{
197	${objtree}/scripts/sorttable ${1}
198}
199
200# Delete output files in case of error
201cleanup()
202{
203	rm -f .btf.*
204	rm -f .tmp_System.map
205	rm -f .tmp_vmlinux*
206	rm -f System.map
207	rm -f vmlinux
208	rm -f vmlinux.o
209}
210
211on_exit()
212{
213	if [ $? -ne 0 ]; then
214		cleanup
215	fi
216}
217trap on_exit EXIT
218
219on_signals()
220{
221	exit 1
222}
223trap on_signals HUP INT QUIT TERM
224
225#
226#
227# Use "make V=1" to debug this script
228case "${KBUILD_VERBOSE}" in
229*1*)
230	set -x
231	;;
232esac
233
234if [ "$1" = "clean" ]; then
235	cleanup
236	exit 0
237fi
238
239# We need access to CONFIG_ symbols
240. include/config/auto.conf
241
242# Update version
243info GEN .version
244if [ -r .version ]; then
245	VERSION=$(expr 0$(cat .version) + 1)
246	echo $VERSION > .version
247else
248	rm -f .version
249	echo 1 > .version
250fi;
251
252# final build of init/
253${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
254
255#link vmlinux.o
256info LD vmlinux.o
257modpost_link vmlinux.o
258
259# modpost vmlinux.o to check for section mismatches
260${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
261
262info MODINFO modules.builtin.modinfo
263${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
264info GEN modules.builtin
265# The second line aids cases where multiple modules share the same object.
266tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
267	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
268
269btf_vmlinux_bin_o=""
270if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
271	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
272	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
273		echo >&2 "Failed to generate BTF for vmlinux"
274		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
275		exit 1
276	fi
277fi
278
279kallsymso=""
280kallsymso_prev=""
281kallsyms_vmlinux=""
282if [ -n "${CONFIG_KALLSYMS}" ]; then
283
284	# kallsyms support
285	# Generate section listing all symbols and add it into vmlinux
286	# It's a three step process:
287	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
288	#     but __kallsyms is empty.
289	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
290	#     the right size
291	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
292	#     the right size, but due to the added section, some
293	#     addresses have shifted.
294	#     From here, we generate a correct .tmp_kallsyms2.o
295	# 3)  That link may have expanded the kernel image enough that
296	#     more linker branch stubs / trampolines had to be added, which
297	#     introduces new names, which further expands kallsyms. Do another
298	#     pass if that is the case. In theory it's possible this results
299	#     in even more stubs, but unlikely.
300	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
301	#     other bugs.
302	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
303	#
304	# a)  Verify that the System.map from vmlinux matches the map from
305	#     ${kallsymso}.
306
307	kallsyms_step 1
308	kallsyms_step 2
309
310	# step 3
311	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
312	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
313
314	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
315		kallsyms_step 3
316	fi
317fi
318
319vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
320
321if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
322	info SORTTAB vmlinux
323	if ! sorttable vmlinux; then
324		echo >&2 Failed to sort kernel tables
325		exit 1
326	fi
327fi
328
329info SYSMAP System.map
330mksysmap vmlinux System.map
331
332# step a (see comment above)
333if [ -n "${CONFIG_KALLSYMS}" ]; then
334	mksysmap ${kallsyms_vmlinux} .tmp_System.map
335
336	if ! cmp -s System.map .tmp_System.map; then
337		echo >&2 Inconsistent kallsyms data
338		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
339		exit 1
340	fi
341fi
342